# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Easiest way to determine version is to build unrar and extract a file with it,
# as it announces its version number
%global beta 1
%global actualversion 5.10
%global tarballversion 5.1.1
%global rpmrel 1.0.cf

Summary:	Extract, test and view RAR archives
Name:		unrar
Version:	%{actualversion}
Release:	%{?beta:0.}%{rpmrel}%{?beta:.beta%{beta}}.%{__distinit}%{__distvers}
License:	Freeware with further limitations
Group:		Applications/Archiving
Url:		http://www.rarlab.com/rar_archiver.htm
Source0:	http://www.rarlab.com/rar/unrarsrc-%{tarballversion}.tar.gz
Source1:	http://ftp.de.debian.org/debian/pool/non-free/u/unrar-nonfree/unrar-nonfree_5.0.10-1.debian.tar.gz
Patch0:		unrar-5.00-missing-recvol-symbols.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
Requires(post):	/usr/sbin/alternatives
Requires(preun): /usr/sbin/alternatives

%description
The unRAR utility is a freeware program, distributed with source code and
developed for extracting, testing and viewing the contents of archives created
with the RAR archiver version 1.50 and above.

%package -n libunrar
Summary:	Decompress library for RAR v3 archives
Group:		System Environment/Libraries

%description -n libunrar
The libunrar library allows programs linking against it to decompress
existing RAR v3 archives.

%package -n libunrar-devel
Summary:	Development files for libunrar
Group:		Development/Libraries
Requires:	libunrar = %{version}-%{release}
Provides:	libunrar3-%{version} = %{version}-%{release}

%description -n libunrar-devel
The libunrar-devel package contains libraries and header files for
developing applications that use libunrar.

%prep
%setup -q -n %{name} -a 1

# Patch to resolve unresolved symbol issues noted in RPM Fusion Bug #1385
%patch0

# Fix line endings
sed -i -e 's/\r$//' readme.txt

%build
# TODO: build the library first and then build the binary against it

# Build the binary
make %{?_smp_mflags} \
	CXX="%{__cxx}" \
	CXXFLAGS="%{optflags} -fPIC -DPIC" \
	STRIP=: \
	RANLIB=ranlib

# Clean objects prior to library build
make %{?_smp_mflags} clean

# Build the library
make %{?_smp_mflags} lib \
	CXX="%{__cxx}" \
	CXXFLAGS="%{optflags} -fPIC -DPIC" \
	LDFLAGS="-Wl,-soname -Wl,libunrar.so.%{version}" \
	STRIP=: \
	RANLIB=ranlib
mv libunrar.so libunrar.so.%{version}

%install
rm -rf %{buildroot}
install -D -m 755 unrar %{buildroot}%{_bindir}/unrar-nonfree
install -D -m 644 -p debian/unrar-nonfree.1 %{buildroot}%{_mandir}/man1/unrar-nonfree.1
install -D -m 755 libunrar.so.%{version} %{buildroot}%{_libdir}/libunrar.so.%{version}
ln -s libunrar.so.%{version} %{buildroot}%{_libdir}/libunrar.so
mkdir -p -m 755 %{buildroot}%{_includedir}/unrar
for header in *.hpp; do
	install -D -p -m 644 $header %{buildroot}%{_includedir}/unrar/$header
done

# Ghost binary and manpage for alternatives
: > %{buildroot}%{_bindir}/unrar
chmod 755 %{buildroot}%{_bindir}/unrar
: > %{buildroot}%{_mandir}/man1/unrar.1

%clean
rm -rf %{buildroot}

%post
/usr/sbin/alternatives \
	--install	%{_bindir}/unrar		unrar		%{_bindir}/unrar-nonfree 50 \
	--slave		%{_mandir}/man1/unrar.1.gz	unrar.1.gz	%{_mandir}/man1/unrar-nonfree.1.gz \
	|| :

%preun
if [ "$1" -eq 0 ]; then
	/usr/sbin/alternatives --remove unrar %{_bindir}/unrar-nonfree || :
fi

%post -n libunrar -p /sbin/ldconfig

%postun -n libunrar -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc license.txt readme.txt
%ghost %{_bindir}/unrar
%{_bindir}/unrar-nonfree
%ghost %{_mandir}/man1/unrar.1.gz
%{_mandir}/man1/unrar-nonfree.1.gz

%files -n libunrar
%defattr(-,root,root,-)
%doc license.txt readme.txt
%{_libdir}/libunrar.so.%{version}

%files -n libunrar-devel
%defattr(-,root,root,-)
%{_includedir}/unrar/
%{_libdir}/libunrar.so

%changelog
* Tue Mar 18 2014 Paul Howarth <paul@city-fan.org> 5.10-0.1.0.cf.beta1
- update to 5.10 beta 1
- update debian patch to 5.0.10-1

* Tue Dec  3 2013 Paul Howarth <paul@city-fan.org> 5.01-1.0.cf
- update to 5.01

* Tue Nov 12 2013 Paul Howarth <paul@city-fan.org> 5.01-0.1.0.cf.beta1
- update to 5.01 beta 1

* Mon Oct 28 2013 Paul Howarth <paul@city-fan.org> 5.00-3.0.cf
- remove unrar-4.2.3-fix-build.patch and add clean step to %%build
  (RPM Fusion #2869)

* Wed Sep 25 2013 Paul Howarth <paul@city-fan.org> 5.00-2.0.cf
- update to 5.0.12 tarball

* Wed Sep  4 2013 Paul Howarth <paul@city-fan.org> 5.00-1.0.cf
- update to 5.00

* Mon Aug  5 2013 Paul Howarth <paul@city-fan.org> 5.00-0.8.0.cf.beta8
- update to 5.00 beta 8

* Mon Jul 15 2013 Paul Howarth <paul@city-fan.org> 5.00-0.7.0.cf.beta7
- update to 5.00 beta 7

* Thu Jun 20 2013 Paul Howarth <paul@city-fan.org> 5.00-0.6.1.cf.beta6
- update to 5.00 beta 6

* Wed Jun 12 2013 Paul Howarth <paul@city-fan.org> 5.00-0.6.0.cf.beta5
- still beta5, upstream's numbering sceme is messy

* Tue May 28 2013 Paul Howarth <paul@city-fan.org> 5.00-0.5.0.cf.beta5
- update to 5.00 beta 5

* Tue May 21 2013 Paul Howarth <paul@city-fan.org> 5.00-0.4.0.cf.beta4
- update to 5.00 beta 4

* Fri May 10 2013 Paul Howarth <paul@city-fan.org> 5.00-0.3.0.cf.beta3
- update to 5.00 beta 3

* Wed May  1 2013 Paul Howarth <paul@city-fan.org> 5.00-0.2.0.cf.beta2
- update to 5.00 beta 2

* Tue Apr 30 2013 Paul Howarth <paul@city-fan.org> 5.00-0.1.0.cf.beta1
- update to 5.00 beta 1
- update patches to apply to new makefile

* Fri Jun 15 2012 Paul Howarth <paul@city-fan.org> 4.20-1.0.cf
- update to 4.20 final
  - RAR general decompression algorithm speed is slightly improved, though not
    to the same extent as RAR compression; RAR decompression is not able to use
    several processor cores, so its performance does not depend on a number of
    cores
- tidy up build process and generate PIC code
- include all header files in the -devel package (RPM Fusion #1988)

* Mon May 28 2012 Paul Howarth <paul@city-fan.org> 4.20-0.1.0.cf.beta3
- update to 4.20 beta 3

* Thu May 17 2012 Paul Howarth <paul@city-fan.org> 4.20-0.1.0.cf.beta2
- update to 4.20 beta 2

* Thu May  3 2012 Paul Howarth <paul@city-fan.org> 4.20-0.1.0.cf.beta1
- update to 4.20 beta 1
- update debian patch to 4.1.4-1

* Tue Jan 17 2012 Paul Howarth <paul@city-fan.org> 4.10-1.0.cf
- update to 4.10 final

* Mon Nov  7 2011 Paul Howarth <paul@city-fan.org> 4.10-0.3.0.cf.beta3
- update to 4.10 beta 3

* Thu Oct 20 2011 Paul Howarth <paul@city-fan.org> 4.10-0.2.0.cf.beta2
- update to 4.10 beta 2

* Tue Oct  4 2011 Paul Howarth <paul@city-fan.org> 4.10-0.1.0.cf.beta1
- update to 4.10 beta 1
- fudge versions as tarball version number bears scant resemblance to the
  actual release version

* Mon Aug  1 2011 Paul Howarth <paul@city-fan.org> 4.0-0.2.0.cf.beta7
- nobody else likes macros for commands
- fix dist tag for CentOS 6 and Scientific Linux

* Tue Mar  8 2011 Paul Howarth <paul@city-fan.org> 4.0-0.1.0.cf.beta7
- update to 4.0.7

* Mon Feb  7 2011 Paul Howarth <paul@city-fan.org> 4.0-0.1.0.cf.beta6
- update to 4.0.6 (GUI/archive maintenance fixes)

* Mon Jan 24 2011 Paul Howarth <paul@city-fan.org> 4.0-0.1.0.cf.beta5
- update to 4.0.5
  - command line mode -ibck switch is applicable to most of archive processing
    operations, not just archiving and extracting
  - "a" and "s" commands with -iicon and -iimg switches did not remove
    temporary files after completion

* Wed Jan  5 2011 Paul Howarth <paul@city-fan.org> 4.0-0.1.0.cf.beta4
- update to 4.0.4
  - previous beta versions could truncate some files extracted from ISO 9660
    archives
- update debian patch to 4.0.3-1

* Mon Dec 20 2010 Paul Howarth <paul@city-fan.org> 4.0-0.1.0.cf.beta3
- update to 4.0.3
  - now switch -ep3 converts not only disk letters, but also UNC paths, so
    \\server\share will be converted to __server\share when archiving and
    restored to the original \\server\share when extracting with -ep3
  - previous beta could fail to unpack self-extracting and multivolume CAB
    archives
  - previous beta crashed when displaying archive comments with ANSI escape
    sequences
  - switches -cl and -cu did not work
- update debian patch to 4.0.2-1

* Fri Nov 26 2010 Paul Howarth <paul@city-fan.org> 4.0-0.1.0.cf.beta2
- update to 4.0.2 (changes in GUI versions, unrar should be unchanged)

* Mon Nov 15 2010 Paul Howarth <paul@city-fan.org> 4.0-0.1.0.cf.beta1
- update to 4.0.1

* Fri Oct  1 2010 Paul Howarth <paul@city-fan.org> 3.9.10-4.0.cf
- rebuild for gcc bug (#634757)

* Wed Sep 29 2010 Paul Howarth <paul@city-fan.org> 3.9.10-3.0.cf
- resolve unresolved symbol issues noted in RPM Fusion Bug #1385

* Thu Sep  9 2010 Paul Howarth <paul@city-fan.org> 3.9.10-2.1.cf
- debian no longer patch the upstream sources and just have an additional
  tarball for the manpage etc. - update to version 3.9.10 of this

* Thu May 13 2010 Paul Howarth <paul@city-fan.org> 3.9.10-2.0.cf
- fix dist tag for RHEL-6 Beta

* Mon Mar 15 2010 Paul Howarth <paul@city-fan.org> 3.9.10-1.0.cf
- update to 3.9.10

* Mon Feb 15 2010 Paul Howarth <paul@city-fan.org> 3.9.9-1.0.cf
- update to 3.9.9

* Sun Jan 24 2010 Paul Howarth <paul@city-fan.org> 3.9.8-1.0.cf
- update to 3.9.8
- update debian patch to 3.9.7-1

* Tue Dec 22 2009 Paul Howarth <paul@city-fan.org> 3.9.7-1.0.cf
- update to 3.9.7
- update debian patch to 3.9.6-1
- dist tag for Rawhide no longer needs special-casing

* Tue Oct 20 2009 Paul Howarth <paul@city-fan.org> 3.9.6-1.0.cf
- update to 3.9.6
- make provide of libunrar3-%%{version} a versioned provide
- make %%ghost-ed %%{_bindir}/unrar have exec bits set to placate rpmlint

* Wed Jul  8 2009 Paul Howarth <paul@city-fan.org> 3.9.5-1.0.cf
- update to 3.9.5
- define RPM macros in global scope
- mention that there are license limitations in the license tag
- update URL to RAR-specific page
- make package RPM Fusion compatible, i.e. include library packages, use
  alternatives

* Mon Sep 10 2007 Paul Howarth <paul@city-fan.org> 3.7.8-1
- update to 3.7.8

* Wed Sep  5 2007 Paul Howarth <paul@city-fan.org> 3.7.7-1
- update to 3.7.7

* Mon Aug 20 2007 Paul Howarth <paul@city-fan.org> 3.7.6-1
- update to 3.7.6

* Fri Mar  2 2007 Paul Howarth <paul@city-fan.org> 3.7.4-1
- update to 3.7.4

* Fri Feb  2 2007 Paul Howarth <paul@city-fan.org> 3.7.3-1
- update to 3.7.3
- fix dist tag for Fedora test releases

* Fri Jan 12 2007 Paul Howarth <paul@city-fan.org> 3.7.2-1
- update to 3.7.2

* Wed Jan 10 2007 Paul Howarth <paul@city-fan.org> 3.7.1-1
- update to 3.7.1

* Wed Sep  6 2006 Paul Howarth <paul@city-fan.org> 3.6.8-2
- Fix distribution tags for development releases

* Thu Aug 17 2006 Paul Howarth <paul@city-fan.org> 3.6.8-1
- update to 3.6.8

* Tue Aug  8 2006 Paul Howarth <paul@city-fan.org> 3.6.7-1
- update to 3.6.7
- simplify distribution-detection
- remove buildroot unconditionally in %%clean and %%install
- remove basic reqs and buildreqs
- fix rpmlint errors

* Tue Feb  1 2005 Paul Howarth <paul@city-fan.org> - 3.4.3-1
- update to 3.4.3
- auto-detect distribution for use in release tag

* Thu Feb 05 2004 Paul Howarth <paul@city-fan.org> - 3.3.4-1
- build for Fedora Core 1.

* Mon Jan 19 2004 Matthias Saou <http://freshrpms.net/> - 3.3.4-1.fr
- Update to 3.3.4.

* Fri Nov  7 2003 Matthias Saou <http://freshrpms.net/> - 3.2.3-1.fr
- Update to 3.2.3.
- Rebuild for Fedora Core 1.

* Wed May 14 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 3.2.1.
- Added missing URL.

* Mon Mar 31 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 3.2.0.
- Rebuilt for Red Hat Linux 9.

* Mon Jan 13 2003 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Update to 3.1.3.

* Thu Oct 10 2002 Matthias Saou <matthias.saou@est.une.marmotte.net>
- Spec file cleanup.

* Sat Oct  5 2002 Ville Skyttä <ville.skytta at iki.fi> 3.00-2cr
- Rebuild for Red Hat 8.0, using the compat GCC.

* Tue Sep 17 2002 Ville Skyttä <ville.skytta at iki.fi> 3.00-1cr
- RedHatified PLD version.

